#include <string.h>
#include "sys.h"
#include "delay.h"
#include "uart.h"
#include "bsp_i2c_ee.h"
#include "bsp_i2c_gpio.h"
#include "w5500.h"
#include "W5500_conf.h"
#include "socket.h"
#include "tftp.h"
	
/********************************************************************************************************
**Ϣ int main (void)                          
** 󣬴ִӡ256ҳ
** 
** 
********************************************************************************************************/
int main(void)
{
	uint8 len,ret;	
	uint8 g_socket_rcv_buf[MAX_MTU_SIZE];
	uint8 filename_flag=0;
	uint32 addr;
	uint32 tftp_server;	
  uint32 app_first_4_bytes;
	
  delay_init();	    	          	//ʱʼ
	NVIC_Configuration();
  uart_initwBaudRate(115200);	 		//ڳʼΪ115200
	i2c_CfgGpio();				    	    //ʼeeprom
	
	printf(" Ƽ--WIZnet W5500ٷ̣ȫ̼֧֣۸ƣ\r\n");
	
	gpio_for_w5500_config();							/*ʼMCU*/
  reset_w5500();												/*ӲλW5500*/
  PHY_check();													/*Ƿ*/   
  set_w5500_mac();											/*MACַ*/
  set_w5500_ip();												/*IPַ*/
  socket_buf_init(txsize, rxsize);			/*ʼ8SocketķͽջС*/

	printf(" ɳʼ!\r\n");
	printf(" Remote IP:%d.%d.%d.%d \r\n",ConfigMsg.lip[0],ConfigMsg.lip[1],ConfigMsg.lip[2],ConfigMsg.lip[3]); 
	printf(" W5500 Init Complete!\r\n");
  printf(" Start TFTP Client Test!\r\n\r\n"); 

	addr = ApplicationAddress;
  app_first_4_bytes = *(vu32*)addr;
	
  if ((app_first_4_bytes & 0xffffffff) == 0xffffffff)				// appǰֽΪ0x08008000˵Flashδ¼app
  { 
		write_config_to_eeprom(); 															// Flash¼app
  }	
	get_config();																							// FlashжȡϢ
	TFTP_init(SOCK_TFTP,g_socket_rcv_buf);										// TFTPʼһ·SocketTFTPͨ

  while(1)															/*ѭִеĺ*/ 
  {
		if((ConfigMsg.newfirm[0]!=ConfigMsg.sw_ver[0])||(ConfigMsg.newfirm[1]!=ConfigMsg.sw_ver[1]))
		{			
			if(USART_RX_STA & 0x8000)  														// 
			{
				len = USART_RX_STA & 0x3fff;												// 㴮ݵĳ
				printf("Send new version app:%s\r\n",USART_RX_BUF);	// ӡ				
				memcpy(ConfigMsg.filename,USART_RX_BUF,len);				// ݼFilenameҪ/дλڷϵļͬ
				USART_RX_STA=0;																			// 0β
				memset(USART_RX_BUF,0,len+1);												// USART_RX_BUF0
				filename_flag=1;																		// Filename־λ1
			}		
			if(filename_flag==1)																	// Filename־λΪ1
			{
				filename_flag=0;																		// Filename־λ0
				printf("TFTP Start!\r\n");
				tftp_server = (remote_ip[0] << 24) | (remote_ip[1] << 16) | (remote_ip[2] << 8) | (remote_ip[3]);		// TFTPIPַ
				TFTP_read_request(tftp_server,ConfigMsg.filename);	// TFTP
				
				while(1)
				{	
					ret = TFTP_run();																	// TFTP
					if(ret != TFTP_PROGRESS)													// TFTP̽תTFTPɹ
					break;
				}
				if(ret == TFTP_SUCCESS)															// TFTPɹ
				{
					printf("TFTP Success!\r\n");								
					delay_ms(10);
					reboot_app();																			// °汾app
				}			
			}
		}
		else																										// ް汾£ɰ汾app
		{
			printf("No new version, run the old version.\r\n");
			reboot_app();																					
		}
  }
}

